EAPI EAPI_WEAK const Efl_Event_Description _EFL_MODEL_EVENT_PROPERTIES_CHANGED =
   EFL_EVENT_DESCRIPTION("properties,changed");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_MODEL_EVENT_CHILD_ADDED =
   EFL_EVENT_DESCRIPTION("child,added");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_MODEL_EVENT_CHILD_REMOVED =
   EFL_EVENT_DESCRIPTION("child,removed");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_MODEL_EVENT_CHILDREN_COUNT_CHANGED =
   EFL_EVENT_DESCRIPTION("children,count,changed");
EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_model_properties_get, Eina_Iterator *, NULL);
EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_model_property_set, Eina_Future *, NULL, EFL_FUNC_CALL(property, value), const char *property, Eina_Value *value);
EAPI EAPI_WEAK EFL_FUNC_BODYV_CONST(efl_model_property_get, Eina_Value *, NULL, EFL_FUNC_CALL(property), const char *property);
EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_model_property_ready_get, Eina_Future *, NULL, EFL_FUNC_CALL(property), const char *property);
EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_model_children_slice_get, Eina_Future *, NULL, EFL_FUNC_CALL(start, count), unsigned int start, unsigned int count);
EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_model_children_index_get, Eina_Future *, NULL, EFL_FUNC_CALL(indices), Eina_Iterator *indices);

static Eina_Value
__eolian_efl_model_children_count_get_reflect(const Eo *obj)
{
   unsigned int val = efl_model_children_count_get(obj);
   return eina_value_uint_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_model_children_count_get, unsigned int, 0);
EAPI EAPI_WEAK EFL_FUNC_BODY(efl_model_child_add, Efl_Object *, NULL);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_model_child_del, EFL_FUNC_CALL(child), Efl_Object *child);

static Eina_Bool
_efl_model_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_MODEL_EXTRA_OPS
#define EFL_MODEL_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_model_properties_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_model_property_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_model_property_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_model_property_ready_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_model_children_slice_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_model_children_index_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_model_children_count_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_model_child_add, NULL),
      EFL_OBJECT_OP_FUNC(efl_model_child_del, NULL),
      EFL_MODEL_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"children_count", NULL, __eolian_efl_model_children_count_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_model_class_desc = {
   EO_VERSION,
   "Efl.Model",
   EFL_CLASS_TYPE_INTERFACE,
   0,
   _efl_model_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_model_interface_get, &_efl_model_class_desc, NULL, NULL);
